// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import jakarta.faces.component.behavior.ClientBehaviorHolder;
import jakarta.faces.context.FacesContext;
import org.apache.myfaces.tobago.internal.component.AbstractUIEvent;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import jakarta.annotation.Generated;
import jakarta.el.ELException;
import jakarta.faces.FacesException;
import jakarta.faces.application.ProjectStage;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import jakarta.el.MethodExpression;
import jakarta.el.ValueExpression;

/**
 Add an event behavior to the component.
  It can contain f:ajax and tc:operation tags.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.EventTagDeclaration}.
 */
@Generated("component.stg")
public class UIEvent
    extends AbstractUIEvent implements ClientBehaviorHolder {

  private static final Tags TAG = Tags.event;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "jakarta.faces.Command";

  private static final Collection<String> EVENT_NAMES = Arrays.asList("change", "click", "input", "dblclick", "focus", "blur", "mouseout", "mouseover", "complete", "load", "reload", "resize");

  @Override
  public Collection<String> getEventNames() {
    return EVENT_NAMES;
  }

  @Override
  public String getDefaultEventName() {
    return "click";
  }


  enum PropertyKeys {
    link,
    confirmation,
    stopPropagation,
    transition,
    target,
    fragment,
    customEventName,
    event,
    omit,
    outcome,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  <p>
   Link to an arbitrary URL, either an internal link or an external link. For internal URLs, a session id will be
   added, if needed (when cookies disabled). The context path needs to be added manually e.g. #{request.contextPath}.
   For JSF navigation to a viewId use the outcome attribute!
   </p>

   <p>
   The semantic of this attributes has been changed from Tobago 3 to 4!
   </p>

  */
  public java.lang.String getLink() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.link);
  }

  public void setLink(java.lang.String link) {
    getStateHelper().put(PropertyKeys.link, link);
  }

  /**
  Text to use as confirmation message.

  */
  public java.lang.String getConfirmation() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.confirmation);
  }

  public void setConfirmation(java.lang.String confirmation) {
    getStateHelper().put(PropertyKeys.confirmation, confirmation);
  }

  /**
  Prevent the JavaScript event from bubbling up.

  */
  public Boolean getStopPropagation() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.stopPropagation);
    if (bool != null) {
      return bool;
    }
    return null;
  }

  public void setStopPropagation(Boolean stopPropagation) {
    getStateHelper().put(PropertyKeys.stopPropagation, stopPropagation);
  }

  /**
  Specify, if the command calls an JSF-Action.
   Useful to switch off the Double-Submit-Check and Waiting-Behavior.
  <br>Default: <code>true</code>
  */
  public boolean isTransition() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.transition);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setTransition(boolean transition) {
    getStateHelper().put(PropertyKeys.transition, transition);
  }

  /**
  Name of a frame where the resource retrieved via this hyperlink is to be
   displayed.

  */
  public java.lang.String getTarget() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.target);
  }

  public void setTarget(java.lang.String target) {
    getStateHelper().put(PropertyKeys.target, target);
  }

  /**
  The identifier of the page fragment which should
   be brought into focus when the target page is
   rendered. The value of this attribute is appended
   to the end of target URL following a hash (#) mark.
   This notation is part of the standard URL syntax.

  */
  public java.lang.String getFragment() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.fragment);
  }

  public void setFragment(java.lang.String fragment) {
    getStateHelper().put(PropertyKeys.fragment, fragment);
  }

  /**
  If set, an additional custom event
   (<a href="https://developer.mozilla.org/en-US/docs/Web/API/CustomEvent">CustomEvent</a>) triggers after the
   original event of the component (e.g. “click” on a tc:button). The name of the custom event is defined by this
   attribute.

  */
  public java.lang.String getCustomEventName() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.customEventName);
  }

  public void setCustomEventName(java.lang.String customEventName) {
    getStateHelper().put(PropertyKeys.customEventName, customEventName);
  }

  /**
  The name of the event as an instance of {

  */
  public org.apache.myfaces.tobago.component.ClientBehaviors getEvent() {
    return (org.apache.myfaces.tobago.component.ClientBehaviors) getStateHelper().eval(PropertyKeys.event);
  }

  public void setEvent(org.apache.myfaces.tobago.component.ClientBehaviors event) {
    getStateHelper().put(PropertyKeys.event, event);
  }

  /**
  Flag indicating that the action of this element, will not be executed from client side
   (e.g. when the user clicks a button.
   When setting this value to true, the action will not be executed by the Tobago, but it can executed
   by JavaScript.
   This attribute is useful, when you want to add JavaScript event handlers to commands manually.
   In this case you usually don't want a submit with a full reload of the page.
  <br>Default: <code>false</code>
  */
  public boolean isOmit() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.omit);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOmit(boolean omit) {
    getStateHelper().put(PropertyKeys.omit, omit);
  }

  /**
  Link to an internal facelet page, like the outcome of an action.
   The context path will be added.
   A session id will be added, if needed.

  */
  public java.lang.String getOutcome() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.outcome);
  }

  public void setOutcome(java.lang.String outcome) {
    getStateHelper().put(PropertyKeys.outcome, outcome);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}